wayland::zwp_tablet_pad_v2_t(3)

NAME
wayland::zwp_tablet_pad_v2_t - a set of buttons, rings and strips

SYNOPSIS

#include <wayland-client-protocol-unstable.hpp>

Inherits wayland::proxy_t.

  Public Types

enum class wrapper_type { standard, display, foreign, proxy_wrapper }

  Public Member Functions

void set_feedback (uint32_t button, std::string const &description, uint32_t serial)
set compositor feedback
std::function< void(zwp_tablet_pad_group_v2_t)> & on_group ()
group announced
std::function< void(std::string)> & on_path ()
path to the device
std::function< void(uint32_t)> & on_buttons ()
buttons announced
std::function< void()> & on_done ()
pad description event sequence complete
std::function< void(uint32_t, uint32_t, zwp_tablet_pad_v2_button_state)> & on_button ()
physical button state
std::function< void(uint32_t, zwp_tablet_v2_t, surface_t)> & on_enter ()
enter event
std::function< void(uint32_t, surface_t)> & on_leave ()
enter event
std::function< void()> & on_removed ()
pad removed event
uint32_t get_id () const
Get the id of a proxy object.
std::string get_class () const
Get the interface name (class) of a proxy object.
uint32_t get_version () const
Get the protocol object version of a proxy object.
wrapper_type get_wrapper_type () const
Get the type of a proxy object.
void set_queue (event_queue_t queue)
Assign a proxy to an event queue.
wl_proxy * c_ptr () const
Get a pointer to the underlying C struct.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
operator bool () const
Check whether this wrapper actually wraps an object.
bool operator== (const proxy_t &right) const
Check whether two wrappers refer to the same object.
bool operator!= (const proxy_t &right) const
Check whether two wrappers refer to different objects.
void proxy_release ()
Release the wrapped object (if any), making this an empty wrapper.

  Static Public Attributes

static constexpr std::uint32_t set_feedback_since_version = 1
Minimum protocol version required for the set_feedback function.

Detailed Description

a set of buttons, rings and strips

A pad device is a set of buttons, rings and strips usually physically present on the tablet device itself. Some exceptions exist where the pad device is physically detached, e.g. the Wacom ExpressKey Remote.

Pad devices have no axes that control the cursor and are generally auxiliary devices to the tool devices used on the tablet surface.

A pad device has a number of static characteristics, e.g. the number of rings. These capabilities are sent in an event sequence after the wp_tablet_seat.pad_added event before any actual events from this pad. This initial event sequence is terminated by a wp_tablet_pad.done event.

All pad features (buttons, rings and strips) are logically divided into groups and all pads have at least one group. The available groups are notified through the wp_tablet_pad.group event; the compositor will emit one event per group before emitting wp_tablet_pad.done.

Groups may have multiple modes. Modes allow clients to map multiple actions to a single pad feature. Only one mode can be active per group, although different groups may have different active modes.

Definition at line 5414 of file wayland-client-protocol-unstable.hpp.

Member Enumeration Documentation

  enum class wayland::proxy_t::wrapper_type [strong], [inherited]
Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator

standard
    C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.

display
    C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign
    C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper
    C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

Member Function Documentation

  wl_proxy * wayland::proxy_t::c_ptr () const [inherited]

Get a pointer to the underlying C struct.

Returns
    The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

  std::string wayland::proxy_t::get_class () const [inherited]

Get the interface name (class) of a proxy object.

Returns
    The interface name of the object associated with the proxy

  uint32_t wayland::proxy_t::get_id () const [inherited]

Get the id of a proxy object.

Returns
    The id the object associated with the proxy

  uint32_t wayland::proxy_t::get_version () const [inherited]

Get the protocol object version of a proxy object. Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
    The protocol object version of the proxy or 0

  wrapper_type wayland::proxy_t::get_wrapper_type () const [inline], [inherited]

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

  std::function< void(uint32_t, uint32_t, zwp_tablet_pad_v2_button_state)> & zwp_tablet_pad_v2_t::on_button ()

physical button state

Parameters
    time the time of the event with millisecond granularity
    button the index of the button that changed state
    state

Sent whenever the physical state of a button changes.

Definition at line 8033 of file wayland-client-protocol-unstable.cpp.

  std::function< void(uint32_t)> & zwp_tablet_pad_v2_t::on_buttons ()

buttons announced

Parameters
    buttons the number of buttons

Sent on wp_tablet_pad initialization to announce the available buttons.

This event is sent in the initial burst of events before the wp_tablet_pad.done event. This event is only sent when at least one button is available.

Definition at line 8023 of file wayland-client-protocol-unstable.cpp.

  std::function< void()> & zwp_tablet_pad_v2_t::on_done ()

pad description event sequence complete This event signals the end of the initial burst of descriptive events. A client may consider the static description of the pad to be complete and finalize initialization of the pad.

Definition at line 8028 of file wayland-client-protocol-unstable.cpp.

  std::function< void(uint32_t, zwp_tablet_v2_t, surface_t)> & zwp_tablet_pad_v2_t::on_enter ()

enter event

Parameters
    serial serial number of the enter event
    tablet the tablet the pad is attached to
    surface surface the pad is focused on

Notification that this pad is focused on the specified surface.

Definition at line 8038 of file wayland-client-protocol-unstable.cpp.

  std::function< void(zwp_tablet_pad_group_v2_t)> & zwp_tablet_pad_v2_t::on_group ()

group announced

Parameters
    pad_group

Sent on wp_tablet_pad initialization to announce available groups. One event is sent for each pad group available.

This event is sent in the initial burst of events before the wp_tablet_pad.done event. At least one group will be announced.

Definition at line 8013 of file wayland-client-protocol-unstable.cpp.

  std::function< void(uint32_t, surface_t)> & zwp_tablet_pad_v2_t::on_leave ()

enter event

Parameters
    serial serial number of the leave event
    surface surface the pad is no longer focused on

Notification that this pad is no longer focused on the specified surface.

Definition at line 8043 of file wayland-client-protocol-unstable.cpp.

  std::function< void(std::string)> & zwp_tablet_pad_v2_t::on_path ()

path to the device

Parameters
    path path to local device

A system-specific device path that indicates which device is behind this wp_tablet_pad. This information may be used to gather additional information about the device, e.g. through libwacom.

The format of the path is unspecified, it may be a device node, a sysfs path, or some other identifier. It is up to the client to identify the string provided.

This event is sent in the initial burst of events before the wp_tablet_pad.done event.

Definition at line 8018 of file wayland-client-protocol-unstable.cpp.

  std::function< void()> & zwp_tablet_pad_v2_t::on_removed ()

pad removed event Sent when the pad has been removed from the system. When a tablet is removed its pad(s) will be removed too.

When this event is received, the client must destroy all rings, strips and groups that were offered by this pad, and issue wp_tablet_pad.destroy the pad itself.

Definition at line 8048 of file wayland-client-protocol-unstable.cpp.

  wayland::proxy_t::operator bool () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  bool wayland::proxy_t::operator!= (const proxy_t & right) const [inherited]

Check whether two wrappers refer to different objects.

  bool wayland::proxy_t::operator== (const proxy_t & right) const [inherited]

Check whether two wrappers refer to the same object.

  bool wayland::proxy_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void wayland::proxy_t::proxy_release () [inherited]

Release the wrapped object (if any), making this an empty wrapper. Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
foreign_display.cpp.

  void zwp_tablet_pad_v2_t::set_feedback (uint32_t button, std::string const & description, uint32_t serial)

set compositor feedback

Parameters
    button button index
    description button description
    serial serial of the mode switch event

Requests the compositor to use the provided feedback string associated with this button. This request should be issued immediately after a wp_tablet_pad_group.mode_switch event from the corresponding group is received, or whenever a button is mapped to a different action. See wp_tablet_pad_group.mode_switch for more details.

Clients are encouraged to provide context-aware descriptions for the actions associated with each button, and compositors may use this information to offer visual feedback on the button layout (e.g. on-screen displays).

Button indices start at 0. Setting the feedback string on a button that is reserved by the compositor (i.e. not belonging to any wp_tablet_pad_group) does not generate an error but the compositor is free to ignore the request.

The provided string 'description' is a UTF-8 encoded string to be associated with this ring, and is considered user-visible; general internationalization rules apply.

The serial argument will be that of the last wp_tablet_pad_group.mode_switch event received for the group of this button. Requests providing other serials than the most recent one will be ignored.

Definition at line 8007 of file wayland-client-protocol-unstable.cpp.

  void wayland::proxy_t::set_queue (event_queue_t queue) [inherited]

Assign a proxy to an event queue.

Parameters
    queue The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
proxy_wrapper.cpp.

Member Data Documentation

  constexpr std::uint32_t wayland::zwp_tablet_pad_v2_t::set_feedback_since_version = 1 [static], [constexpr]

Minimum protocol version required for the set_feedback function.

Definition at line 5479 of file wayland-client-protocol-unstable.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.